# Contributing

Contributions are made through pull requests into the main branch of the repository. Each pull request must be reviewed with at least one maintainer from each of the affected sections of the code base.

### Merge Requirements

|Requirement|Action|
|---|---|
|Approval|Non-involved maintainer or core development member must comment `Approved` on the PR after reviewing code to be merged.|
|CI|A continuous integration build must pass.|
|Code Style|Code must be the same as the rest of the codebase.|
|Manual Test|Code must be manually tested to ensure that it is working as intended.|

All of these requirements can be bypassed within good reason by a core development member - if this is the case it should be commented on the pull request.

### Maintainers

|Integration|Maintainer|
|---|---|
|Facebook|[@mrkno](https://github.com/mrkno)|
|Grunt|[@Awarua-](https://github.com/Awarua-)|
|Discord|[@Awarua-](https://github.com/Awarua-)|
|Messenger|[@mrkno](https://github.com/mrkno)|
|MS/Skype Bots|[@Awarua-](https://github.com/Awarua-)|
|Skype|[@mrkno](https://github.com/mrkno)|
|Slack|[@Awarua-](https://github.com/Awarua-)|
|Telegram|[@phillipadsmith](https://github.com/phillipadsmith)|
|Test|[@mrkno](https://github.com/mrkno)|

|Feature|Maintainer|
|---|---|
|Docker|[@MatthewHartstonge](https://github.com/MatthewHartstonge)|
|Core|[`core-development` Github Team](https://github.com/orgs/concierge/teams/core-development)|
|Tests|[@Awarua-](https://github.com/Awarua-)|
|Repository|[@mrkno](https://github.com/mrkno)|

|Translation|Maintainer|
|---|---|
|en|[`core-development` Github Team](https://github.com/orgs/concierge/teams/core-development)|
|pl|[@p0358](https://github.com/p0358)|
|hi|[@ParasDPain](https://github.com/ParasDPain)|
